#include "parse.h"
#include "comp.h"
#include "y.tab.h"
#include "ex1.h"
#include "conv.h"
#include "eval.h"

extern struct keyword token[MAX_TOKEN];


int TRAITEMENT_vCHAR(nodeType * Node)
{
 /* Evaluation du premier argument de CHAR */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de CHAR */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de CHAR */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction CHAR */
 fprintf(fPrg, "\tjsr %s\t\t;Call to CHAR\n", Int2StrHexa(token[Node->op.oper].adr));	
 return 1;
}

/* 2E1-2E2 : RADIUS  */
/* 2E3-2E4 : FB  */
int TRAITEMENT_vCIRCLE(nodeType * Node)
{
 /* Evaluation du premier argument de CIRCLE */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de CIRCLE */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Appel  la fonction CIRCLE */
 fprintf(fPrg, "\tjsr %s\t\t;Call to CIRCLE\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}


int TRAITEMENT_vCLS(nodeType * Node)
{
 /* Appel de la fonction CLS */
 fprintf(fPrg, "\tjsr %s\t\t;Call to CLS\n", Int2StrHexa(token[Node->op.oper].adr));
 
 return 1;
}


/* 2E1-2E2 : X  */
/* 2E3-2E4 : Y  */
/* 2E5-2E6 : FB */
int TRAITEMENT_vCURMOV(nodeType * Node)
{
 /* Evaluation du premier argument de CURMOV */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de CURMOV */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de CURMOV */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction CURMOV */
 fprintf(fPrg, "\tjsr %s\t\t;Call to CURMOV\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}

/* 2E1-2E2 : X  */
/* 2E3-2E4 : Y  */
/* 2E5-2E6 : FB */
int TRAITEMENT_vCURSET(nodeType * Node)
{
 /* Evaluation du premier argument de CURSET */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de CURSET */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de CURSET */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction CURSET */
 fprintf(fPrg, "\tjsr %s\t\t;Call to CURSET\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}


/* 2E1-2E2 : X  */
/* 2E3-2E4 : Y  */
/* 2E5-2E6 : FB */
int TRAITEMENT_vDRAW(nodeType * Node)
{
 /* Evaluation du premier argument de DRAW */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de DRAW */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de DRAW */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction DRAW */
 fprintf(fPrg, "\tjsr %s\t\t;Call to DRAW\n", Int2StrHexa(token[Node->op.oper].adr));	
	
 return 1;
}


/* 2E1-2E2 : Nb de colonnes  */
/* 2E3-2E4 : Nb de cellules  */
/* 2E5-2E6 : Value           */
int TRAITEMENT_vFILL(nodeType * Node)
{
 /* Evaluation du premier argument de FILL */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de FILL */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de FILL */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction FILL */
 fprintf(fPrg, "\tjsr %s\t\t;Call to FILL\n", Int2StrHexa(token[Node->op.oper].adr));	
	
 return 1;
}

int TRAITEMENT_vHIRES(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to HIRES\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}

int TRAITEMENT_vINK(nodeType * Node)
{
 /* Evaluation du premier argument de INK */
 eval_byte(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Appel  la fonction INK */
 fprintf(fPrg, "\tjsr %s\t\t;Call to INK\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}

int TRAITEMENT_vLORES(nodeType * Node)
{
 fprintf(fPrg, "\tlda %s\t\t\t; Function LORES\n" , Const2StrHexa(Node->op.args[0]->con.u.iValue));
 fprintf(fPrg, "\tsta v0TxtPtr\n");
 fprintf(fPrg, "\tlda %s\n"                       , Const2StrHexa(0));
 fprintf(fPrg, "\tsta v0TxtPtr+1\n");
 fprintf(fPrg, "\tjsr %s\t\t; Call to ROM_LORES\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}


int TRAITEMENT_vLPRINT(OpNodeType * Node)
{
 return 1;
}


int TRAITEMENT_vPAPER(nodeType * Node)
{
 /* Evaluation du premier argument de PAPER */
 eval_byte(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Appel  la fonction PAPER */
 fprintf(fPrg, "\tjsr %s\t\t;Call to PAPER\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}


/* 2E1-2E2 : Pattern  */
int TRAITEMENT_vPATTERN(nodeType * Node)
{
 /* Evaluation du premier argument de PATTERN */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Appel  la fonction PATTERN */
 fprintf(fPrg, "\tjsr %s\t\t;Call to PATTERN\n", Int2StrHexa(token[Node->op.oper].adr));	
 	
 return 1;
}

int TRAITEMENT_vPLOT(OpNodeType * Node)
{
 return 1;
}

int TRAITEMENT_vPOINT(OpNodeType * Node)
{
 return 1;
}

int TRAITEMENT_vPRINT(OpNodeType * Node)
{
 return 1;
}

int TRAITEMENT_vSCRN(OpNodeType * Node)
{
 return 1;
}

int TRAITEMENT_vSPC(OpNodeType * Node)
{
 
 return 1;
}

int TRAITEMENT_vTEXT(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to TEXT\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}

int TRAITEMENT_vPOS(OpNodeType * Node)
{
 return 1;
}

int TRAITEMENT_vTAB(OpNodeType * Node)
{
 return 1;
}
