#include <stdlib.h>
#include "parse.h"
#include "comp.h"
#include "y.tab.h"
#include "ex1.h"
#include "conv.h"
#include "eval.h"

extern struct keyword token[MAX_TOKEN];

/** FUNCTION : initParamK7
*
*/

void initParamK7(void)
{
 fprintf(fPrg, "\tlda 0\t\t\t;Initialisation parametre K7\n");
 fprintf(fPrg, "\tsta v2TSpeedK7\n");
 fprintf(fPrg, "\tsta v2VerifyK7\n");
 fprintf(fPrg, "\tsta v2JoinK7\n");
 fprintf(fPrg, "\tsta v2CLoadCSave1\n");
 fprintf(fPrg, "\tsta v2CLoadCSave2\n");
 fprintf(fPrg, "\tsta v2ErrFormatK7_???\n"); 
 fprintf(fPrg, "\tsta v2HeaderInfoK7+6\n");  
 fprintf(fPrg, "\tsta v2HeaderInfoK7+7\n");  
}


/** FUNCTION : copyFilenameK7
*
*/
/* Ne teste pas la longueur du nom de fichier ... */
void copyFilenameK7(void)
{
 fprintf(fPrg, "\tlda #v2FilenameSave\n");
 fprintf(fPrg, "\tsta v0Target\n");
 fprintf(fPrg, "\tlda #v2FilenameSave+1\n");
 fprintf(fPrg, "\tsta v0Target+1\n");
 fprintf(fPrg, "\tldy 0xFF\n");
 fprintf(fPrg, "BCL_%d:\n", 1);
 fprintf(fPrg, "\tiny\n");
 fprintf(fPrg, "\tlda (v0Index),Y\n");
 fprintf(fPrg, "\tsta (v0Target),Y\n");
 fprintf(fPrg, "\tbne BCL_%d\n", 1); 
}

/** FUNCTION : TRAITEMENT_vCLOAD
*
*/
int TRAITEMENT_vCLOAD(nodeType * Node)
{
 int i = 0;
 
 /* INIT PARAM */
 (void) initParamK7();
 
 /* Evaluation du premier argument de CLOAD */
 eval_str(Node->op.args[0], "v0Index");
 
 /* Recopie du nom du programme a charger dans v2FilenameSave */
 (void) copyFilenameK7();
   
 /* Evaluation des parametres suivants */
 i=1;
 while (i < Node->op.nops) {
 
  switch (Node->op.args[i]->type) {
   case tiConst : 
        if (Node->op.args[i]->con.u.iValue == K7_AUTO) {
           fprintf(fPrg, "\tlda 1\t\t\t\t\t\t;Initialisation parametre AUTO K7\n");
           fprintf(fPrg, "\tsta v2AUTOK7\n");  
        }
        else {
           fprintf(fPrg, "comp_K7.c : TRAITEMENT_vCLOAD() : Erreur argument '%d' pour type=tiConst\n", Node->op.args[i]->con.u.iValue);
           exit(1);          
        }        
        break;
   case tsConst :
        switch (Node->op.args[i]->con.u.sValue[0]) {
         case 'S' : fprintf(fPrg, "\tlda 1\t\t\t;Set slow speed\n");
                    fprintf(fPrg, "\tsta v2TSpeedK7\t\t\n");
                    break;
         case 'J' : fprintf(fPrg, "\tlda 1\t\t\t;Set join mode\n");
                    fprintf(fPrg, "\tsta v2JoinK7\t\t\n");
                    break;
         case 'V' : fprintf(fPrg, "\tlda 1\t\t\t;Set verify mode\n");
                    fprintf(fPrg, "\tsta v2JoinK7\t\t\n");
                    break;
         default  : fprintf(fPrg, "comp_K7.c : TRAITEMENT_vCLOAD() : Erreur argument '%s'\n", Node->op.args[i]->con.u.sValue);
                    exit(1);
                    break;
        }                
        break;
   default :
       fprintf(fPrg, "comp_K7.c : TRAITEMENT_vCLOAD() : Erreur type '%d'\n", Node->op.args[i]->type);
       exit(1);
       break;    
  } /* fin du switch */
  i++;      
  
 }
 
 /* Appel de la fonction CLOAD */                                              
 fprintf(fPrg, "\tjsr %s+4\t\t;Call to CLOAD\n", Int2StrHexa(token[Node->op.oper].adr));    
 return 1;
}


/** FUNCTION : TRAITEMENT_vCSAVE
*
*/	
int TRAITEMENT_vCSAVE(nodeType * Node)
{
 int i = 0;
 
 /* INIT PARAM */
 (void) initParamK7();
 
 /* Evaluation du premier argument de CSAVE */
 eval_str(Node->op.args[0], "v0Index");
 
 /* Recopie du nom du programme a sauver dans v2FilenameSave */
 (void) copyFilenameK7();
  
 /* Evaluation des parametres suivants */
 i=1;
 while (i < Node->op.nops) {
 
  switch (Node->op.args[i]->type) {
   case tiConst : 
        if (Node->op.args[i]->con.u.iValue == K7_AUTO) {
           fprintf(fPrg, "\tlda 1\t\t\t\t\t\t;Initialisation parametre AUTO K7\n");
           fprintf(fPrg, "\tsta v2AUTOK7\n");  
        }
        else {
           fprintf(fPrg, "comp_K7.c : TRAITEMENT_vSAVE() : Erreur argument '%d' pour type=tiConst\n", Node->op.args[i]->con.u.iValue);
           exit(1);          
        }        
        break;;
   case tsConst :
        switch (Node->op.args[i]->con.u.sValue[0]) {
         case 'A' : eval_int(Node->op.args[i+1], "v2AK7");
                    i++;
                    break;
         case 'E' : eval_int(Node->op.args[i+1], "v2EK7");
                    i++;
                    break;                    
         case 'S' : fprintf(fPrg, "\tlda 1\t\t\t\t\t\t;Set slow speed\n");
                    fprintf(fPrg, "\tsta v2TSpeedK7\t\t\n");
                    break;
         default  : fprintf(fPrg, "comp_K7.c : TRAITEMENT_vSAVE() : Erreur argument '%s' pour type=tsConst\n", Node->op.args[i]->con.u.sValue);
                    exit(1);
                    break;
        }
        break;
   default :
       fprintf(fPrg, "comp_K7.c : TRAITEMENT_vSAVE() : Erreur type '%d'\n", Node->op.args[i]->type);
       exit(1);
       break;    
  } /* fin du switch */
  i++;
 }

 /* Appel de la fonction CSAVE */                                              
 fprintf(fPrg, "\tjsr %s+35\t\t;Call to CSAVE\n", Int2StrHexa(token[Node->op.oper].adr));     
 return 1;
}


/** FUNCTION : TRAITEMENT_vSTORE
*
*/	
int TRAITEMENT_vSTORE(nodeType * Node)
{
 int i = 0;
 
 /* INIT PARAM */
 (void) initParamK7();

 /* Evaluation du deuxieme argument de STORE (nom du fichier)*/
 eval_str(Node->op.args[1], "v0Index");
 
 /* Recopie du nom du programme a sauver dans v2FilenameSave */
 (void) copyFilenameK7();
 
 /* Test mode lent */
 if (Node->op.nops = 3) {
    switch (Node->op.args[2]->con.u.sValue[0]) {
     case 'S' : fprintf(fPrg, "\tlda 1\t\t\t\t\t\t;Set slow speed\n");
                fprintf(fPrg, "\tsta v2TSpeedK7\t\t\n");
                break;
     default  : fprintf(fPrg, "comp_K7.c : TRAITEMENT_vSTORE() : Erreur argument '%s'\n", Node->op.args[2]->con.u.sValue);
                exit(1);
                break;
    }
 }
 
 /* SAUVEGARDE DE LA VARIABLE */
 fprintf(fPrg, "\tSAUVEGARDE TABLEAU A FAIRE (STORE)\n");
  
 return 1;
}


/** FUNCTION : TRAITEMENT_vRECALL
*
*/	
int TRAITEMENT_vRECALL(nodeType * Node)
{
  int i = 0;
 
 /* INIT PARAM */
 (void) initParamK7();

 /* Evaluation du deuxieme argument de RECALL (nom du fichier)*/
 eval_str(Node->op.args[1], "v0Index");
 
 /* Recopie du nom du programme a sauver dans v2FilenameSave */
 (void) copyFilenameK7();
 
 /* Test mode lent */
 if (Node->op.nops = 3) {
    switch (Node->op.args[2]->con.u.sValue[0]) {
     case 'S' : fprintf(fPrg, "\tlda 1\t\t\t\t\t\t;Set slow speed\n");
                fprintf(fPrg, "\tsta v2TSpeedK7\t\t\n");
                break;
     default  : fprintf(fPrg, "comp_K7.c : TRAITEMENT_vRECALL() : Erreur argument '%s'\n", Node->op.args[2]->con.u.sValue);
                exit(1);
                break;
    }
 }
 
 /* RESTAURATION DE LA VARIABLE */
 fprintf(fPrg, "\tRESTAURATION TABLEAU A FAIRE (RECALL)\n");
  
 return 1;
}

