#include "parse.h"   
#include "comp.h"    
#include "y.tab.h"   
#include "ex1.h"     
#include "conv.h"
#include "eval.h"

extern struct keyword token[MAX_TOKEN];

/* 2E1-2E2 : CHANNEL */
/* 2E3-2E4 : OCTAVE  */
/* 2E5-2E6 : NOTE    */
/* 2E7-2E8 : VOLUME  */
int TRAITEMENT_vMUSIC(nodeType * Node)
{
 /* Evaluation du premier argument de MUSIC */
 eval_int(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de MUSIC */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de MUSIC */
 eval_int(Node->op.args[2], "v2_ParamGrSnd_3");

 /* Evaluation du quatrieme argument de MUSIC */
 eval_int(Node->op.args[3], "v2_ParamGrSnd_4");

 /* Appel  la fonction MUSIC */
 fprintf(fPrg, "\tjsr %s\t\t;Call to MUSIC\n", Int2StrHexa(token[Node->op.oper].adr));	
 return 1;
}

/* 2E1-2E2 : TONE ENABLE     */
/* 2E3-2E4 : NOISE ENABLE    */
/* 2E5-2E6 : ENVELOPE        */
/* 2E7-2E8 : ENVELOPE PERIOD */
int TRAITEMENT_vPLAY(nodeType * Node)
{
/* Evaluation du premier argument de PLAY */
 eval_byte(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de PLAY */
 eval_byte(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de PLAY */
 eval_byte(Node->op.args[2], "v2_ParamGrSnd_3");

 /* Evaluation du quatrieme argument de PLAY */
 eval_byte(Node->op.args[3], "v2_ParamGrSnd_4");

 /* Appel  la fonction PLAY */
 fprintf(fPrg, "\tjsr %s\t\t;Call to PLAY\n", Int2StrHexa(token[Node->op.oper].adr));	
 
 return 1;
}

/* 2E1-2E2 : CHANNEL */
/* 2E3-2E4 : PERIOD  */
/* 2E5-2E6 : VOLUME  */
int TRAITEMENT_vSOUND(nodeType * Node)
{
 /* Evaluation du premier argument de SOUND */
 eval_byte(Node->op.args[0], "v2_ParamGrSnd_1");
 
 /* Evaluation du deuxieme argument de SOUND */
 eval_int(Node->op.args[1], "v2_ParamGrSnd_2");
 
 /* Evaluation du troisieme argument de SOUND */
 eval_byte(Node->op.args[2], "v2_ParamGrSnd_3");
 
 /* Appel  la fonction SOUND */
 fprintf(fPrg, "\tjsr %s\t\t;Call to SOUND\n", Int2StrHexa(token[Node->op.oper].adr));
 	
 return 1;
}


int TRAITEMENT_vEXPLODE(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to EXPLODE\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}

int TRAITEMENT_vPING(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to PING\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}

int TRAITEMENT_vSHOOT(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to SHOOT\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}


int TRAITEMENT_vZAP(nodeType * Node)
{
 fprintf(fPrg, "\tjsr %s\t\t;Call to ZAP\n", Int2StrHexa(token[Node->op.oper].adr));
 return 1;
}

