#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "parse.h"
#include "y.tab.h"
#include "ex1.h"
#include "compilateur.h"
#include "conv.h"

void createHeader(void)
{
 fprintf(fHeader, "\n\t .org %s\n", Int2StrHexa(0x500)); 
 fprintf(fHeader, "\n\t v0ValTyp         equ 0x0028");
 fprintf(fHeader, "\n\t v0LineNum        equ 0x0033");
 fprintf(fHeader, "\n\t v0Begin          equ 0x0091");
 fprintf(fHeader, "\n\t v0Target         equ 0x00A4");
 fprintf(fHeader, "\n\t v0ACC1           equ 0x00D0");
 fprintf(fHeader, "\n\t v0ACC2           equ 0x00D8");
 fprintf(fHeader, "\n\t v0STRING1        equ 0x00DE");
 fprintf(fHeader, "\n\t v2TSpeedK7       equ 0x024D");
 fprintf(fHeader, "\n\t v2JoinK7         equ 0x025A");
 fprintf(fHeader, "\n\t v2VerifyK7       equ 0x025B");
 fprintf(fHeader, "\n\t v2CloadCsave1    equ 0x025C");
 fprintf(fHeader, "\n\t v2CloadCsave2    equ 0x025D");
 fprintf(fHeader, "\n\t v2LetterK7       equ 0x025E");
 fprintf(fHeader, "\n\t v2FilenameSave   equ 0x027F");
 fprintf(fHeader, "\n\t v2FilenameFromK7 equ 0x0293");
 fprintf(fHeader, "\n\t v2HeaderInfoK7   equ 0x02A7");
 fprintf(fHeader, "\n\t v2AK7            equ 0x02A9");
 fprintf(fHeader, "\n\t v2EK7            equ 0x02AB");
 fprintf(fHeader, "\n\t v2TmpK7          equ 0x02B0");
 fprintf(fHeader, "\n\t v2ErrFormatK7    equ 0x02B1");
 fprintf(fHeader, "\n\t v2_ParamGrSnd    equ 0x02E0"); 
 fprintf(fHeader, "\n\t v2_ParamGrSnd_1  equ 0x02E1"); 
 fprintf(fHeader, "\n\t v2_ParamGrSnd_2  equ 0x02E3"); 
 fprintf(fHeader, "\n\t v2_ParamGrSnd_3  equ 0x02E5"); 
 fprintf(fHeader, "\n\t v2_ParamGrSnd_4  equ 0x02E7"); 
 fprintf(fHeader, "\n\t v2AdrPtExcl      equ 0x02F5"); 
 fprintf(fHeader, "\n\t v2JmpPtAmpersand equ 0x02FB"); 
 fprintf(fHeader, "\n\t v2AdrPtAmpersand equ 0x02FC"); 
 fprintf(fHeader, "\n\n");	
}

/*========================*/
/*=== COMPILE THE CODE ===*/
/*========================*/
int COMPILATION(struct nodetypeliste * pListeLine) {
 struct nodetypeliste * pTmpListLine = NULL;
 int iNumLine = 0;
 NodeVariable p;
 
 pTmpListLine = pListeLine;
 iLib1 = 0;
 iLib2 = 0;

 if (pListeLine == NULL) printf("compilateur.c : COMPILATION(): pListeLine is a NULL pointer\n");
 
 (void) createHeader();
 
 
 /* Init. Variable */
 iAdrVarFlt = 0x500;
 iAdrVarInt = 0x500;
 iAdrVarStr = 0x500;
 iAdrCode   = 0x500;
 pOffset    = 0;
 
 /* List of Variables */
 iAdrVarStr;
 p = pListeVarStr; 
 if (p == NULL) { printf("compilateur.c : COMPILATION() : p of string  is a NULL POINTER\n"); }
 while (p != NULL) {
 	fprintf(fHeader, "\n\t VAR_%s db 256\n", p->sName);
 	p = p->Next;
 	pOffset+=256;
 }
 
 iAdrVarFlt += pOffset;
 p = pListeVarFlt;  
 if (p == NULL) { printf("compilateur.c : COMPILATION() : p of float   is a NULL POINTER\n"); }
 while (p != NULL) {
 	fprintf(fHeader, "\n\t VAR_%s db $00,$00,$00,$00,$00,$00,$00", p->sName);
 	p = p->Next;
 	pOffset+=7;
 }

 iAdrVarInt += pOffset; 
 p = pListeVarInt; 
 if (p == NULL) { printf("compilateur.c : COMPILATION() : p of integer is a NULL POINTER\n"); }
 while (p != NULL) {
 	fprintf(fHeader, "\n\t VAR_%s db $00,$00,$00,$00,$00,$00,$00", p->sName);
 	p = p->Next;
 	pOffset+=7;
 }
  
 fprintf(fHeader, "\n\n;---- BEGIN OF PROGRAM ----\n\n");
  
 iAdrCode += pOffset;
 
 printf("\niAdrVarStr=%s\n", Int2StrHexa(iAdrVarStr));
 printf("iAdrVarFlt=%s\n"  , Int2StrHexa(iAdrVarFlt));
 printf("iAdrVarInt=%s\n"  , Int2StrHexa(iAdrVarInt));
 printf("iAdrCode  =%s\n\n", Int2StrHexa(iAdrCode  ));
 
 /* Generate assembly code */ 
 while (pTmpListLine != NULL) {
   print(pTmpListLine->Node);
   pTmpListLine = pTmpListLine->Next;
 }
  
 fprintf(fPrg, "\n\t.end\n");
 fprintf(fPrg, "\n\n\n");
}

/*
void GENERATE_CODE_NODE(nodeType * Node, int iRegCible)
{
 int iRegAux=2;
 nodeType * Tree;
 
 while (Node != NULL) {
   CALCUL_POIDS(Node);
   Tree = ARBRE_PAS_TROP_GRAND_MAXIMAL(Node);
   GENERATE_CODE(TREE, iRegCible, iRegAux);
   if (Node != Tree) {
     iRegTemp=GetRegTemp();
     GENERATE("STORE R", iRegCible, ",T", iRegTemp);
     REPLACE(Tree, iRegTemp);
     SetRegTemp();
   }
   else {
     SetRegTemp();
     Node=NULL;
   }    
 }
}

void GENERATE_CODE(nodeType * Noeud, Registre Cible)
{
 Ensemble de reg aux <- Ensemble de registre disponible \ registre cible;
 while (Noeud != NULL)
 {
  Calculer le poids de tous les noeuds de l'arbre Noeud;
  Noeud arbre <- arbre pas trop grand maximal(Noeud);
  Genere du code (Noeud arbre, Registre cible, Ensemble de registres auxiliaires);
  SI Noeud arbre <> Noeud
    Emplacement temporaire <- prochain emplacement  temporaire libre ();
    PRODUIRE ("STORE R" registre cible ",T" emplacement temporaire;
    REMPLACER Noeud arbre par une referencce à Emplacement temporaire;
    REMETTRE tout emplacement temporaire de Noeud arbre dans l'ensemble des emplacements temporaires libres;
 SINON Noeud arbre = Noeud
    REMETTRE tout emplacement temporaire de Noeud arbre dans l'ensemble des emplacements temporaires libres;
    Noeud <= null;
 }
}


nodeType * Arbre_pas_trop_grand_maximal (nodeType * Noeud, int iRegAux) 
{ 
 if (Noeud.poids <= iRegAux) return Noeud;
 if (Noeud.gauche.poids > iRegAux) return Arbre_pas_trop_grand_maximal(Noeud.gauche, iRegAux);
 else if (Noeud.droit.poids >= iRegAux) return Arbre_pas_trop_grand_maximal(Noeud.droit, iRegAux);
}
*/
