#include <string.h>
#include "stdio.h"
#include "stdlib.h"
#include "parse.h"
#include "conv.h"

/**
* FUNCTION : convertit un entier en sa representation hexadecimal
*            sort du programme si l'entier est trop grand
* IN       : un entier a convertir
* OUT      : une chaine contenant la representation hexadecimal
*/
char * Int2StrHexa(int iNb)
{
  char * sTmp;
  
  if (iNb > 65535) { printf("conv.c: Int2StrHexa() : number too large\n"); exit(1); }  
  sTmp = (char *) malloc((6+1) * sizeof(char));    
  sprintf(sTmp, "$%X", iNb);  
  return sTmp;
}

char * Const2StrHexa(int iNb)
{
  char * sTmp;
  if (iNb > 65535) { printf("conv.c: Const2StrHexa() : number too large\n"); exit(1); }  
  
  sTmp = (char *) malloc((7+1) * sizeof(char));    
  sprintf(sTmp, "#$%X", iNb);  
  return sTmp;
}


char * AdrVarInt2StrHexa(char * sName, int iOff)
{
 char * sTmp;
 int iPos, iAdr;
  
  if (iAdr > 65535) { printf("conv.c: AdrVarInt2StrHexa() : number too large\n"); exit(1); }    
  sTmp = (char *) malloc((7 + 1) * sizeof(char));  
  iPos = posVariable(sName, pListeVarInt);  
  iAdr = /* cAdrInt */ 0x600 + (iPos * cNbByteVarInt) + iOff;      
  sprintf(sTmp, "#$%X", iAdr);  
  return sTmp;
}


char * AdrVarFlt2StrHexa(char * sName, int iOff)
{
 char * sTmp;
 int iPos, iAdr;
    
  sTmp = (char *) malloc((7 + 1) * sizeof(char));  
  iPos = posVariable(sName, pListeVarFlt);  
  iAdr = /* cAdrFlt */ 0x700 + (iPos * cNbByteVarFlt) + iOff;    
  if (iAdr > 65535) { printf("conv.c: AdrVarFlt2StrHexa() : number too large\n"); exit(1); }  
  sprintf(sTmp, "#$%X", iAdr);  
  return sTmp;
}


char * AdrVarStr2StrHexa(char * sName, int iOff)
{
 char * sTmp;
 int iPos, iAdr;
    
  sTmp = (char *) malloc((7 + 1) * sizeof(char));  
  iPos = posVariable(sName, pListeVarStr);  
  iAdr = iOff + (iPos * cNbByteVarStr);    
  if (iAdr > 65535) { printf("conv.c: AdrVarStr2StrHexa() : number too large\n"); exit(1); }  
  sprintf(sTmp, "#$%X", iAdr);  
  return sTmp;
}


char * GetLenVarStr2StrHexa(char * sName)
{
 char * sTmp;
 int iPos, iAdr;  
 
  sTmp = (char *) malloc((7 + 1) * sizeof(char));  
  iPos = posVariable(sName, pListeVarStr);  
  iAdr = /* cAdrStr */ 0x800 + (iPos * cNbByteVarStr) + 2;    
  if (iAdr > 65535) { printf("conv.c: GetLenVarStr2StrHexa() : number too large\n"); exit(1); }  
  sprintf(sTmp, "#$%X", iAdr);  
  return sTmp;
}

char * Adr2StrHexa(int iNb)
{
  char * sTmp;
  
  sTmp = (char *) malloc((7 + 1) * sizeof(char));         
  if (iNb > 65535) { printf("conv.c: Adr2StrHexa() : number too large\n"); exit(1); }  
  sprintf(sTmp, "#$%X", iNb);  
  return sTmp;
}
