#include <stdlib.h>
#include "parse.h"
#include "conv.h"
#include "ex1.h"
#include "macro.h"
#include "eval.h"
#include "compilateur.h"

/* Variable externe */
extern struct keyword token[MAX_TOKEN];
extern char * tabTYPE_OP[11];

/*==================================================================================*/

/*
* Node : les données à compiler
* UseAccu : accumulateur à utiliser
*/
void eval(nodeType * Node, int UseAccu)
{
 int i = 0;
 
 printf("eval.c : eval() : BEGIN\n");
 printf("eval.c : eval() : parametrage : UseAccu=%d\n", UseAccu);

 fprintf(fPrg, "\t*** EVALUATION eval() ***\n");

 if (Node == NULL) { fprintf(fPrg, "eval.c: eval() : Node==NULL, Sortie\n"); return; }

 fprintf(fPrg, "eval.c : eval() : Node->op.type=%d\n", Node->op.type);
 printf("eval.c : eval() : Node->op.type=%s\n", tabTYPE_OP[Node->op.type]);
 
 switch (Node->op.type) {

  case tfConst : fprintf(fPrg, "eval.c: eval() : tfConst non fait\n"); break;

  case tfVar   : fprintf(fPrg, "\tlda %s\n"        , Node->var.sValue);
                 fprintf(fPrg, "\tsta v0ACCU%d\n"  , UseAccu);
                 fprintf(fPrg, "\tlda %s+1\n"      , Node->var.sValue);
                 fprintf(fPrg, "\tsta v0ACCU%d+1\n", UseAccu);
                 fprintf(fPrg, "\tlda %s+2\n"      , Node->var.sValue);
                 fprintf(fPrg, "\tsta v0ACCU%d+2\n", UseAccu);
                 fprintf(fPrg, "\tlda %s+3\n"      , Node->var.sValue);
                 fprintf(fPrg, "\tsta v0ACCU%d+3\n", UseAccu);
                 fprintf(fPrg, "\tlda %s+4\n"      , Node->var.sValue);
                 fprintf(fPrg, "\tsta v0ACCU%d+4\n", UseAccu);
                 break;

  case tiConst :
                 i = Node->con.u.iValue;
                 if (i > 65535) { fprintf(fPrg, "eval.c: eval_int() : Constant integer too large\n"); exit(1); }
                 fprintf(fPrg, "\tlda %d\n", (char) (i >> 8));
                 fprintf(fPrg, "\tsta v0ACC%d\n", UseAccu);
                 fprintf(fPrg, "\tlda %d\n", (char) (i & 0xFF));
                 fprintf(fPrg, "\tsta v0ACC%d+1\n", UseAccu);
                 fprintf(fPrg, "\tlda #$0\n");
                 fprintf(fPrg, "\tsta v0ACC%d+2\n", UseAccu);
                 fprintf(fPrg, "\tsta v0ACC%d+3\n", UseAccu);
                 fprintf(fPrg, "\tsta v0ACC%d+4\n", UseAccu);
                 fprintf(fPrg, "\tsta v0ACC%d+5\n", UseAccu);
                 break;

  case tiVar   : fprintf(fPrg, "eval.c: eval() : tiVar non fait\n"); break;

  case tsConst : eval_str(Node, "v0String"); break;

  case tsVar   : eval_str(Node, "v2LineNum"); break;

  /* La récursion ... */
  default      : printf("eval.c: eval() : default, oper=%d\n",Node->op.oper); 
                 fprintf(fPrg, "eval.c: eval() : default\n"); 
                 token[Node->op.oper].fct(Node); 
                 //if (UseAccu == 2) { fprintf(fPrg, "eval.c: eval() : appel du transfert ACC1 vers ACC2\n");  ACC1_TO_ACC2(); }
                 break;
  
  printf("eval.c : eval() : END\n");
 }

 /* fprintf(fPrg, "\t*** FIN-EVALUATION ***\n"); */
}

/*==================================================================================*/
void eval_int(nodeType * Node, char * sUseAccu)
{
 int i = 0;

 fprintf(fPrg, "\t*** EVALUATION INTEGER***\n");

  if (Node == NULL) { fprintf(fPrg, "eval.c: eval_int() Node==NULL\n"); return; }

 /* fprintf(fPrg, "eval.c: eval_int() Node->op.type=%d\n", Node->op.type); */

 switch (Node->op.type) {

  case tfConst : fprintf(fPrg, "eval.c: eval_int() : tfConst non fait\n"); break;

  case tfVar   : fprintf(fPrg, "eval.c: eval_int() : tfVar non fait\n"); break;

  case tiConst :
                 i = Node->con.u.iValue;
                 if (i > 65535) { fprintf(fPrg, "eval.c: eval_int() : Constant integer too large\n"); exit(1); }
                 printf("i=%i\n",i);
                 fprintf(fPrg, "\tlda %d\n"  , (char) (i >> 8));
                 fprintf(fPrg, "\tsta %s+1\n", sUseAccu);                 
                 fprintf(fPrg, "\tlda %d\n"  , (unsigned char) (i & 0xFF));
                 fprintf(fPrg, "\tsta %s\n"  , sUseAccu);
                 break;

  case tiVar   : fprintf(fPrg, "eval.c: eval_int() : tiVar non fait\n"); break;

  case tsConst : eval_str(Node, "v0String"); break;

  case tsVar   : eval_str(Node, "v2LineNum"); break;

  default :      token[Node->op.oper].fct(Node); break;
 }

 return ;
}

/*==================================================================================*/
void eval_float(nodeType * Node, char * sStore)
{
 int i = 0;

 fprintf(fPrg, "\t*** EVALUATION FLOAT***\n");

  if (Node == NULL) { fprintf(fPrg, "eval.c: eval_float() Node==NULL\n"); return; }

 fprintf(fPrg, "eval.c: eval_float() Node->op.type=%d\n", Node->op.type);

 switch (Node->op.type) {

  case tfConst : fprintf(fPrg, "eval.c: eval_float() : tfConst non fait\n"); break;
 
  case tfVar   :
                 fprintf(fPrg, "\tlda %s\n"  , Node->var.sValue);
                 fprintf(fPrg, "\tsta %s\n"  , sStore);
                 fprintf(fPrg, "\tlda %s+1\n", Node->var.sValue);
                 fprintf(fPrg, "\tsta %s+1\n", sStore);
                 fprintf(fPrg, "\tlda %s+2\n", Node->var.sValue);
                 fprintf(fPrg, "\tsta %s+2\n", sStore);
                 fprintf(fPrg, "\tlda %s+3\n", Node->var.sValue);
                 fprintf(fPrg, "\tsta %s+3\n", sStore);
                 fprintf(fPrg, "\tlda %s+4\n", Node->var.sValue);
                 fprintf(fPrg, "\tsta %s+4\n", sStore);
                 break;

  case tiConst :
                 i = Node->con.u.iValue;
                 if (i > 65535) { fprintf(fPrg, "eval.c: eval_float() : Constante integer too large\n"); exit(1); }
                 printf("i=%i\n",i);
                 fprintf(fPrg, "\tlda %d\n"  , (char) (i >> 8));
                 fprintf(fPrg, "\tsta %s\n"  , sStore);
                 fprintf(fPrg, "\tlda %d\n"  , (unsigned char) (i & 0xFF));
                 fprintf(fPrg, "\tsta %s+1\n", sStore);
                 fprintf(fPrg, "\tlda $00\n" , sStore);
                 fprintf(fPrg, "\tsta %s+2\n", sStore);
                 fprintf(fPrg, "\tsta %s+3\n", sStore);
                 fprintf(fPrg, "\tsta %s+4\n", sStore);
                 break;

  case tiVar   : fprintf(fPrg, "eval.c: eval_float() : tiVar non fait\n"); break;

  case tsConst : eval_str(Node, "v0String"); break;

  case tsVar   : eval_str(Node, "v2LineNum"); break;

  default :      token[Node->op.oper].fct(Node); break;
 }

 return ;
}


/*==================================================================================*/

void eval_byte(nodeType * Node, char * sUseObject)
{
 int i = 0;

 fprintf(fPrg, "\t*** EVALUATION BYTE ***\n");

  if (Node == NULL) { fprintf(fPrg, "eval.c: eval_byte() Node==NULL\n"); return; }

 switch (Node->op.type) {

  case tfConst : fprintf(fPrg, "eval.c: eval_byte() : tfConst non fait\n"); break;

  case tfVar   : fprintf(fPrg, "eval.c: eval_byte() : tfVar non fait\n"); break;

  case tiConst : 
                 i = Node->con.u.iValue;
                 if (i > 255) { fprintf(fPrg, "eval.c: eval_byte() : Constant byte too large\n"); exit(1); }
                 fprintf(fPrg, "\tlda %d\n", (char) i);
                 fprintf(fPrg, "\tsta %s\n", sUseObject);
                 break;

  case tiVar   : fprintf(fPrg, "eval.c: eval_byte() : tiVar non fait\n"); break;

  case tsConst : eval_str(Node, "v0String"); break;

  case tsVar   : eval_str(Node, "v2LineNum"); break;

  default :      token[Node->op.oper].fct(Node); break;
 }
 
 return ;
}

/*==================================================================================*/

void eval_str(nodeType * Node, char * sUseObject)
{
 fprintf(fPrg, "\t*** EVALUATION STRING ***\n");
 
 if (Node == NULL) { fprintf(fPrg, "eval.c: eval_str() Node==NULL\n"); return; }
    
 /* fprintf(fPrg, "eval.c: eval_str() Node->op.type=%d\n", Node->op.type); */
 
 switch (Node->op.type) {
  case  tsConst : 
                  fprintf(fCstStr, "\tCstr_%d equ %s,0\n", iNumString, Node->con.u.sValue);
                  fprintf(fPrg, "\tlda %s_%d\n"   , "Cstr", iNumString);
                  fprintf(fPrg, "\tsta %s\n"      , sUseObject);                     
                  fprintf(fPrg, "\tlda %s_%d+1\n" , "Cstr", iNumString);
                  fprintf(fPrg, "\tsta %s+1\n"    , sUseObject);                                       
                  iNumString++;
                  break;
                  
  case  tsVar   : 
                  fprintf(fPrg, "\tlda %s\n"   , AdrVarStr2StrHexa(Node->var.sValue, iAdrVarStr));
                  fprintf(fPrg, "\tsta %s\n"   , sUseObject);
                  fprintf(fPrg, "\tlda %s+1\n" , AdrVarStr2StrHexa(Node->var.sValue, iAdrVarStr));
                  fprintf(fPrg, "\tsta %s+1\n" , sUseObject);                  
                  break;
                  
  default :       token[Node->op.oper].fct(Node); 
                  break;
 }

 return ;
}

/*==================================================================================*/

/**
*
*/
void ACC1_TO_VAR_FLT(nodeType * Node)
{
 fprintf(fPrg, "\tlda v0ACC1\n");
 fprintf(fPrg, "\tsta VAR_%s\n", Node->var.sValue);
 fprintf(fPrg, "\tlda v0ACC1+1\n");
 fprintf(fPrg, "\tsta VAR_%s+1\n", Node->var.sValue);
 fprintf(fPrg, "\tlda v0ACC1+2\n");
 fprintf(fPrg, "\tsta VAR_%s+2\n", Node->var.sValue);
 fprintf(fPrg, "\tlda v0ACC1+3\n");
 fprintf(fPrg, "\tsta VAR_%s+3\n", Node->var.sValue);
 fprintf(fPrg, "\tlda v0ACC1+4\n");
 fprintf(fPrg, "\tsta VAR_%s+4\n", Node->var.sValue);
}

/**
*
*/
void ACC1_TO_VAR_INT(nodeType * Node)
{
 fprintf(fPrg, "\tlda v0ACC1+1\n");
 fprintf(fPrg, "\tsta VAR_%s\n"  , Node->var.sValue);
 fprintf(fPrg, "\tlda v0ACC1+2\n");
 fprintf(fPrg, "\tsta VAR_%s+1\n", Node->var.sValue);
}

/**
*
*/
void ACC1_TO_ACC2()
{
 fprintf(fPrg, "\tlda v0ACC1\t\t;TRANSFERT ACC1 vers ACC2\n");
 fprintf(fPrg, "\tsta v0ACC2\n");
 fprintf(fPrg, "\tlda v0ACC1+1\n");
 fprintf(fPrg, "\tsta v0ACC2+1\n");
 fprintf(fPrg, "\tlda v0ACC1+2\n");
 fprintf(fPrg, "\tsta v0ACC2+2\n");
 fprintf(fPrg, "\tlda v0ACC1+3\n");
 fprintf(fPrg, "\tsta v0ACC2+3\n");
 fprintf(fPrg, "\tlda v0ACC1+4\n");
 fprintf(fPrg, "\tsta v0ACC2+4\n"); 
}

/**
*
*/
void INT_TO_VAR(nodeType * Node_VALUE, nodeType * Node_VAR)
{
   int i = Node_VALUE->con.u.iValue;
   if (i > 65535) { fprintf(fPrg, "eval.c: eval_int() : Constant integer too large\n"); exit(1); }
   fprintf(fPrg, "\tlda %d\n"  , (char) (i >> 8));
   fprintf(fPrg, "\tsta %s\n"  , Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda %d\n"  , (char) (i & 0xFF));
   fprintf(fPrg, "\tsta %s+1\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda #$0\n");
   fprintf(fPrg, "\tsta %s+2\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tsta %s+3\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tsta %s+4\n", Node_VAR->var.sValue);
}

/**
*
*/
void VAR_TO_VAR(nodeType * Node_VAR_SOURCE , nodeType * Node_VAR)
{
   fprintf(fPrg, "\tlda %s\n"  , Node_VAR_SOURCE->var.sValue);
   fprintf(fPrg, "\tsta %s\n"  , Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda %s+1\n", Node_VAR_SOURCE->var.sValue);
   fprintf(fPrg, "\tsta %s+1\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda %s+2\n", Node_VAR_SOURCE->var.sValue);
   fprintf(fPrg, "\tsta %s+2\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda %s+3\n", Node_VAR_SOURCE->var.sValue);
   fprintf(fPrg, "\tsta %s+3\n", Node_VAR->var.sValue);
   fprintf(fPrg, "\tlda %s+4\n", Node_VAR_SOURCE->var.sValue);
   fprintf(fPrg, "\tsta %s+4\n", Node_VAR->var.sValue);
   
}